# Internet Of Things - Worksheet 3

![image](src/uwe.png)

**Module Name:** Internet Of Things

**Module Code:** UFCFVK‑15‑2

**Module Leader Name:** Benedict R. Gaster

- [Internet Of Things - Worksheet 3](#internet-of-things---worksheet-3)
  - [Description](#description)
    - [Task 1: UDP decoder.](#task-1-udp-decoder)
    - [Task 2: Checksum.](#task-2-checksum)
    - [Task 3: Server UDP time.](#task-3-server-udp-time)
  - [Demos](#demos)
  - [Getting Started](#getting-started)
    - [Dependencies](#dependencies)
    - [Installing](#installing)
  - [Authors](#authors)
  - [Version History](#version-history)
  - [License](#license)

## Description
Worksheet 3:  
-This worksheet explored the UDP protocol. We will be decoding, encoding and comunicating with it in this rep  
**-This is a rep for only worksheet 3.**
* [IOT - Worksheet 2 part 1 ](https://gitlab.uwe.ac.uk/jo2-holdsworth/iot-worksheet-2-part-1) can be found here  
* [IOT - Worksheet 2 part 2 ](https://gitlab.uwe.ac.uk/jo2-holdsworth/iot-worksheet-2-part-2) can be found here 
* [IOT - Worksheet 3](https://gitlab.uwe.ac.uk/jo2-holdsworth/iot-worksheet-3) **you are here**  

### Task 1: UDP decoder.
* *The CSCT cloud server has a port open on 5612 which transmits and receives UDP packets. We are to create a basic client to receive the hello message from the UDP server and decode it.
* ***server.py*** This is the foundation of the worksheet. It connects a and receives the packet from the server. It uses **asyncio** which allows parallelism. As the program it waiting for the response from the server It will continue with other parts of the program. ![image](src/screenshot1.PNG)
* ***udpdecoder.py*** This file contains two functions a decoder and a print function. I choose to do this so we can access the decoder or print in the future. They will be useful separate.
  * **decodePacket(response)** Takes the raw udp pack and outputs a dictionary. Using the function `int.from_bytes(packet,'little')` we can decode bytes straight into ints. Following this table we can decode the UDP packet. Source port is bytes 0,1. Dest Port is bytes 2,3. Data Length is bytes 4,5. Checksum is bytes 6,7. The rest is the payload. ![image](src/screenshot2.PNG) the code: ![image](src/screenshot3.PNG)
  * **printUDPPacket(dict)** Takes the decoded packet and prints the packet in a user friendly format. ![image](src/screenshot4.PNG)![image](src/screenshot5.PNG)
* ***unittest.py*** unittest is an inbuilt Python library. Its a test runner and is specially design for running tests and debugging. This one contains a few useful tools that we are going to use. It works similarly to the assert function. Ive written a few tests to test decoding the packet. All the tests were successful.![image](src/screenshot13.PNG)
___
### Task 2: Checksum.
* To check that the packet is valid from the server we can use the checksum included within the header. We will compute our own checksum to compare the two values and see if they are a match. If they match we can be confident that the packet was transmitted successfully from the server.
* ***compute_checksum(sourcePort, destPort, payload)*** Takes in arguments in ints and calcuates the expected UDP checksum. This uses python bits wise operations and `.to_bytes(2, 'little')` to convert ints to bytes. This took many tries to get working, took a deeper understanding of udp to get working correctly. ![image](src/screenshot6.PNG)
* ***check_checksum(checksum0,checksum1)*** is a very simple function that returns true of false if a check sum is the same. ![image](src/screenshot7.PNG)
* ***print_checksum(dict)*** similar to `printUDPPacket()` it prints the packet and outputs if the check sum is the same. E.I if a valid packet or not. ![image](src/screenshot8.PNG) ![image](src/screenshot9.PNG)
* ***unittest.py*** unittest is an inbuilt Python library. Its a test runner and is specially design for running tests and debugging. This one contains a few useful tools that we are going to use. It works similarly to the assert function. Ive written a few tests to test the checksum. All the tests were successful.![image](src/screenshot14.PNG)
___
### Task 3: Server UDP time.
* This takes builds upon **task 1** and **task 2** we need to send and receive packets from the sever with the correct checksum. This means encoding and decoding UDP.
* ***mainSendandReceive()*** This function is a controller for smaller functions. It simply connects to server and tells the program to send and get packets from the server.![image](src/screenshot10.PNG)
* ***recv_and_decode_packet(websocket)***  We are taking a websocket connecting to it and printing the packet all it one. This take doesnt require us todo much else with the packet so it can just be called in a function. ![image](src/screenshot11.PNG)
* ***send_packet(websocket, sourcePort, deskPort, payLoad)*** To send packets to the server they need to be in UDP format in base64. This function will create a header for the payload including the correct checksum so the server can confirm the packet has arrived valid. ![image](src/screenshot12.PNG)
* ***unittest.py*** unittest is an inbuilt Python library. Its a test runner and is specially design for running tests and debugging. This one contains a few useful tools that we are going to use. It works similarly to the assert function. Task 3 doesn't have any output other than to the terminal. I could alter the output but this is out of my scope for the project. Here I am just checking if the program runs correctly. All the tests were successful.![image](src/screenshot15.PNG)![image](src/screenshot16.PNG)
___
## Demos
* ***Task 1:***  
  **https://www.youtube.com/embed/_whlYriiWjs**  
  ![video](src/demo1.mp4) 
* ***Task 2:***  
  **https://www.youtube.com/embed/1Am2Eauk4dY**  
  ![video](src/demo2.mp4) 
* ***Task 3:***  
  **https://www.youtube.com/embed/wndZ8pPSINo**  
  ![video](src/demo3.mp4) 

___
## Getting Started

* Running the task files
  * Task 1: `python3 udpdecoder.py`
  * Task 2: `python3 checksum.py`
  * Task 3: `python3 serverudptime.py`

### Dependencies

* unittest
* asyncio
* websockets
* json
* time
* base64

### Installing

* Nothing to install

## Authors

Contributors names and contact info

ex. Jack Holdsworth @ [my website](https://holdsworth.dev)

## Version History
* 0.4
  * README
  * Unittesting
* 0.3
  * task 2 done
  * started task 3
* 0.2
  * most of task 2 done
  * README made
* 0.1
  * init.

## License
This project is licensed under the GPL License - see the LICENSE.md file for details
