# ==============
# File: checksum.py
# By: Jack Holdsworth - 20023933
# Use: a program to calculate a udp checksum given inputs
# Written on: Python 3.8
# ==============

from udpdecoder import *

def compute_checksum(sourcePort, destPort, payload):
    # a function to calculate the checksum from packet data (ints)

    # convert ints back to bytes
    sourcePort = sourcePort.to_bytes(2, 'little')
    destPort = destPort.to_bytes(2, 'little')
    length = (len(payload)+8).to_bytes(2, 'little')

    # append bytes 
    calc = sourcePort + destPort + length + bytes(2) + payload
    sum = 0

    # make odd num of bytes even
    if len(payload) % 2:
        calc += bytes(1)

    #take two bytes and bit shit, add them append to sum
    for i in range(0, len(calc), 2):
        tmp = (calc[i] << 8) + calc[i+1]
        sum += tmp
        
    # mask bits
    sum = (sum >> 16) + (sum & 0xFFFF)
    # invert
    sum = ~sum & 0xFFFF
    # output int
    sum = int(format(sum,'b'),2)
    return sum

def check_checksum(checksum0,checksum1):
    # a simple function to check if two values are the same
    if checksum0 == checksum1:
        return True
    else:
        return False
    
def print_checksum(dict):
    # print the dictionary + checksum
    checksum= compute_checksum(dict['Source Port'],dict['Dest Port'], dict['Server Sent'][8:(len(dict['Server Sent'])+8)])
    printUDPPacket(dict)
    print(f"Server checksum: {dict['Checksum']}")
    print(f"Client Calculated checksum: {checksum}")
    # compare checksums and output result
    if check_checksum(dict['Checksum'],checksum) == True:
        print("Match!")
    else:
        print("ERROR!")
    print("=====================================")

if __name__ == '__main__':
    x = 0
    print("=== Task 2 by Jack H ===")
    while x <= 10:
        packet = asyncio.run(getPacket())
        dict = decodePacket(packet)
        print_checksum(dict)
        time.sleep(1)
        x += 1
    print("========================")