# ==============
# File: server.py
# By: Jack Holdsworth - 20023933
# Use: a program to get packets from the udp server
# Written on: Python 3.8
# ==============

import asyncio
import websockets
import json
import time


async def getPacket():
    # connect to server and get packet
    uri = "ws://localhost:5612" # server port
    async with websockets.connect(uri) as websocket: #connect
        # get packet
        return await websocket.recv()


async def recv_message(websocket):
    message = json.loads(await websocket.recv()) # strip json
    return message['payload'] # return packet

if __name__ == "__main__":
    print("Server packet getter")

    while 1:
        print(asyncio.run(getPacket()))
        time.sleep(1)