# ==============
# File: serverudptime.py
# By: Jack Holdsworth - 20023933
# Use: Task 3, a program to get time from a server via udp
# Written on: Python 3.8
# ==============

from checksum import *

async def mainSendandReceive():
    # connect to server, send and get packet with time.
    uri = "ws://localhost:5612" # server port
    async with websockets.connect(uri) as websocket: #connect
        await recv_and_decode_packet(websocket) # get packet decode and print
        x = 0
        while x <= 10:
            await send_packet(websocket, 0, 542, b'1111') # get time packet
            await recv_and_decode_packet(websocket) # decode and print time packet
            time.sleep(1)
            x += 1

async def recv_and_decode_packet(websocket):
    # get packet and print user readable
    message = await websocket.recv() # get packet
    dict = decodePacket(message) # decode
    print_checksum(dict) # print


async def send_packet(websocket, sourcePort, destPort, payload):
    # a function to send a packet via UDP

    # compute checksum
    checkSum = compute_checksum(sourcePort, destPort, payload)

    # convert to bytes
    destPort = destPort.to_bytes(2, 'little')
    sourcePort = sourcePort.to_bytes(2, 'little')
    length = 8 + len(payload)
    length = length.to_bytes(2, 'little')
    checkSum = checkSum.to_bytes(2, 'little')
    # build packet
    packet = sourcePort + destPort + length + checkSum + payload
    # covert packet
    packet = base64.b64encode(packet)
    await websocket.send(packet) # send a move on while sending

if __name__ == '__main__':
    x = 0
    print("=== Task 3 by Jack H ===")
    asyncio.run(mainSendandReceive())
    print("========================")