# ==============
# File: udpdecoder.py
# By: Jack Holdsworth - 20023933
# Use: Task 1, a udp packet decoder uses server.py
# Written on: Python 3.8
# ==============
from server import *
import base64

def decodePacket(response):
    # takes in a packet and outputs a decoded dictionary
    decoded = {} # the dict
    decoded['Base64'] = response # the base64 response from server (raw)
    packet = base64.b64decode(response) # decoded into hex
    decoded['Server Sent'] = packet # decoded hex
    decoded['Source Port'] = int.from_bytes(packet[:2], 'little') # server port
    decoded['Dest Port'] = int.from_bytes(packet[2:4], 'little') # going to
    decoded['Data Length'] = int.from_bytes(packet[4:6], 'little') # length of the payload + 8
    decoded['Checksum'] = int.from_bytes(packet[6:8], 'little') # server calculated checksum
    decoded['Payload'] = packet[8:(len(packet)+8)].decode("utf-8") # the message
    return decoded # return dict

def printUDPPacket(dict):
    # print the dictionary
    print("=== Decoded UDP Packet ===")
    for key, value in dict.items():
        print(f"{key}: {value}")
    print("==========================")

if __name__ == '__main__':
    x = 0
    print("=== Task 1 by Jack H ===")
    while x <= 10:
        printUDPPacket(decodePacket(asyncio.run(getPacket())))
        time.sleep(1)
        x += 1
    print("========================")