# ==============
# File: unittest.py
# By: Jack Holdsworth - 20023933
# Use: A simple program to unittest the tasks from worksheet 3
# Written on: Python 3.8
# ==============
import unittest
import datetime 
from serverudptime import *

class TestMorse(unittest.TestCase):
# task 1
    def test_decode_packet_1(self):
        self.assertEqual(decodePacket(asyncio.run(getPacket())), {'Base64': b'CgAqACEAyztXZWxjb21lIHRvIElvVCBVRFAgU2VydmVy', 'Server Sent': b'\n\x00*\x00!\x00\xcb;Welcome to IoT UDP Server', 'Source Port': 10, 'Dest Port': 42, 'Data Length': 33, 'Checksum': 15307, 'Payload': 'Welcome to IoT UDP Server'})
    def test_decode_packet_2(self):
        self.assertEqual(decodePacket(b'AAAeAhcAC8JJT1QgSVMgVEhFIEJFU1Q='), {'Base64': b'AAAeAhcAC8JJT1QgSVMgVEhFIEJFU1Q=', 'Server Sent': b'\x00\x00\x1e\x02\x17\x00\x0b\xc2IOT IS THE BEST', 'Source Port': 0, 'Dest Port': 542, 'Data Length': 23, 'Checksum': 49675, 'Payload': 'IOT IS THE BEST'})
    def test_decode_packet_3(self):
        self.assertEqual(decodePacket(b'FAAeAiUAU/1Db21tdW5pY2F0aW9uIHdpdGggdGhlIHNlcnZlcg=='), {'Base64': b'FAAeAiUAU/1Db21tdW5pY2F0aW9uIHdpdGggdGhlIHNlcnZlcg==', 'Server Sent': b'\x14\x00\x1e\x02%\x00S\xfdCommunication with the server', 'Source Port': 20, 'Dest Port': 542, 'Data Length': 37, 'Checksum': 64851, 'Payload': 'Communication with the server'})
    def test_decode_packet_4(self):
        self.assertEqual(decodePacket(b'FAAeAiUAU/1Db21tdW5pY2F0aW9uIHdpdGggdGhlIHNlcnZlcg=='), {'Base64': b'FAAeAiUAU/1Db21tdW5pY2F0aW9uIHdpdGggdGhlIHNlcnZlcg==', 'Server Sent': b'\x14\x00\x1e\x02%\x00S\xfdCommunication with the server', 'Source Port': 20, 'Dest Port': 542, 'Data Length': 34, 'Checksum': 64851, 'Payload': 'Communication with the server'})
    def test_decode_packet_5(self):
        self.assertEqual(decodePacket(b'FAArABQAY49CZXN0IHN0dWRlbnQ='), {'Base64': b'FAArABQAY49CZXN0IHN0dWRlbnQ=', 'Server Sent': b'\x14\x00+\x00\x14\x00c\x8fBest student', 'Source Port': 20, 'Dest Port': 43, 'Data Length': 20, 'Checksum': 36708, 'Payload': 'Best student'})

# task 2
    def test_checksum_1(self):
        self.assertEqual(compute_checksum(0,400,b'AACQAQwAJJxUZXN0'), 44976)
    def test_checksum_2(self):
        self.assertEqual(compute_checksum(10,200,b'CgDIABcAbG1Jb3QgaXMgdGhlIEJlc3Q='), 53000)
    def test_checksum_3(self):
        self.assertEqual(compute_checksum(10,200,b'CgDIABcAbG1Jb3QgaXMgdGhlIEJlc3Q='), 53001)
    def test_check_checksum_4(self):
        self.assertEqual(check_checksum(compute_checksum(10,200,b'CgDIABcAbG1Jb3QgaXMgdGhlIEJlc3Q='),53000), True)
    def test_check_checksum_5(self):
        self.assertEqual(check_checksum(compute_checksum(10,200,b'CgDIABcAbG1Jb3QgaXMgdGhlIEJlc3Q='),53001), False)
    def test_check_checksum_6(self):
        self.assertEqual(check_checksum(compute_checksum(10,200,b'CgDIABcAbG1Jb3QgaXMgdGhlIEJlc3Q='),53000), False)

# task 3
    def test_all(self):
        self.assertEqual(asyncio.run(mainSendandReceive()), None)

if __name__ == '__main__':
    unittest.main()
